indexing

   description: "Class that covers Posix signal.h."

   author: "Berend de Boer"
   date: "$Date: Sat, 14 Oct 2000 21:20:04 +0200 $"
   revision: "$Revision: 1.2 $"

class 

   PAPI_SIGNAL


feature {NONE} -- C binding functions
   
   posix_kill (a_pid: INTEGER; sig: INTEGER): INTEGER is
         -- Sends a signal to a process
      external "C"
      end
   

feature {NONE} -- struct sigaction
   
   posix_sa_flags (act: POINTER): INTEGER is
         -- Get struct sigaction member
      external "C"
      end

   posix_sa_handler (act: POINTER): POINTER is
         -- Get struct sigaction member
      external "C"
      end

   posix_set_sa_flags (act: POINTER; a_flags: INTEGER) is
         -- Set struct sigaction member
      external "C"
      end

   posix_set_sa_handler (act: POINTER; a_handler: POINTER) is
         -- Set struct sigaction member
      external "C"
      end
   
   posix_sigaction(sig: INTEGER; act, oact: POINTER): INTEGER is
         -- Examines and changes signal action
      external "C"
      end

   posix_sigaction_size: INTEGER is
         -- Size of struct sigaction
      external "C"
      end
   
   
feature {NONE} -- C binding for members of sigevent

   posix_sigevent_size: INTEGER is
      external "C"
      end

   posix_sigevent_sigev_notify (a_sigevent: POINTER): INTEGER is
      external "C"
      end

   posix_sigevent_sigev_signo (a_sigevent: POINTER): INTEGER is
      external "C"
      end

   posix_sigevent_sigev_notify_function (a_sigevent: POINTER): POINTER is
      external "C"
      end

   posix_sigevent_sigev_notify_attributes (a_sigevent: POINTER): POINTER is
      external "C"
      end

   posix_set_sigevent_sigev_notify (a_sigevent: POINTER; sigev_notify: INTEGER) is
      external "C"
      end

   posix_set_sigevent_sigev_signo (a_sigevent: POINTER; sigev_signo: INTEGER) is
      external "C"
      end

   
feature {NONE} -- sigevent notify values
   
   SIGEV_NONE: INTEGER is
      external "C"
      alias "const_sigev_none"
      end

   SIGEV_SIGNAL: INTEGER is
      external "C"
      alias "const_sigev_signal"
      end

   SIGEV_THREAD: INTEGER is
      external "C"
      alias "const_sigev_thread"
      end


end -- class PAPI_SIGNAL
