indexing

   description: "Class that covers Posix sys/stat.h."

   author: "Berend de Boer"
   date: "$Date: Sat, 05 Aug 2000 14:28:49 +0200 $"
   revision: "$Revision: 1.1 $"

class 

   PAPI_STAT


feature {NONE} -- functions   

   posix_chmod (a_path: POINTER; a_mode: INTEGER): INTEGER is
         -- Changes file mode
      external "C"
      end

   posix_fstat (fildes: INTEGER; a_stat: POINTER): INTEGER is
         -- Gets file status
      require
         valid_stat_buffer: a_stat /= default_pointer
      external "C"
      ensure
         -- Result = -1 implies errno.is_not_ok
      end

   posix_mkdir (path: POINTER; mode: INTEGER): INTEGER is
         -- Makes a directory
      external "C"
      end

   posix_mkfifo (a_path: POINTER; a_mode: INTEGER): INTEGER is
         -- Makes a FIFO special file
      external "C"
      end

   posix_stat (a_path: POINTER; a_stat: POINTER): INTEGER is
         -- Gets information about a file
      require
         valid_stat_buffer: a_stat /= default_pointer
      external "C"
      ensure
         -- Result = -1 implies errno.is_not_ok
      end

   posix_umask (a_mask: INTEGER): INTEGER is
         -- Turn off permission bits specified in `a_mask'
      external "C"
      ensure
         -- previous mask is returned
      end


feature {NONE} -- POSIX C interface
   
   stat_size: INTEGER is
         -- return size of struct stat
      external "C"
      alias "posix_stat_size"
      end


feature {NONE} -- POSIX C stat member interface

   posix_st_gid (a_stat: POINTER): INTEGER is
      external "C"
      end
   
   posix_st_ino (a_stat: POINTER): INTEGER is
      external "C"
      end

   posix_st_mode (a_stat: POINTER): INTEGER is
      external "C"
      end
   
   posix_st_mtime (a_stat: POINTER): INTEGER is
      external "C"
      end
   
   posix_st_size (a_stat: POINTER): INTEGER is
      external "C"
      end
   
   posix_st_uid (a_stat: POINTER): INTEGER is
      external "C"
      end


end -- class PAPI_STAT
