indexing

   description: "Base class for simple CGI programs. Outputs XHTML."

   author: "Berend de Boer"
   date: "$Date: Mon, 18 Sep 2000 21:05:28 +0200 $"
   revision: "$Revision: 1.2 $"

class 

   POSIX_CGI

inherit
   
   POSIX_CURRENT_PROCESS

   XML_GENERATOR
      rename
         xml as document
      redefine
         extend
      end


feature -- overrule some xml stuff   
   
   extend (stuff: STRING) is
      do
         stdout.puts (stuff)
         precursor (stuff)
      end
   
feature -- cgi header
   
   content_text is
      do
         extend ("Content-Type: text/html")
         new_line
         new_line
      end

   doctype is   
      do
         add_header
         extend ("<!DOCTYPE html PUBLIC %"-//W3C//DTD XHTML 1.0 Strict//EN%"%
                 % %"DTD/xhtml1-strict.dtd%">")
         new_line
      end


feature -- page

   b_html is
         -- start html page
      do
         start_tag ("html")
         set_attribute ("xmlns", "http://www.w3.org/1999/xhtml")
         set_attribute ("xml:lang", "en")
         set_attribute ("lang", "en")
      end

   e_html is
      require
         valid_stop: is_started ("html")
      do
         stop_tag
      end

feature -- header
   
   b_head is
      do
         start_tag ("head")
      end
   
   e_head is
      require
         valid_stop: is_started ("head")
      do
         stop_tag
      end

   title (a_text: STRING) is
      require
         -- head started
      do
         add_tag ("title", a_text)
      end


feature -- body
   
   b_body is
      do
         start_tag ("body")
      end

   e_body is
      require
         valid_stop: is_started ("body")
      do
         stop_tag
      end

   b_p is
      do
         start_tag ("p")
      end

   e_p is
      require
         valid_stop: is_started ("p")         
      do
         stop_tag
      end
   
   p (par: STRING) is
      do
         add_tag ("p", par)
      end

end -- class POSIX_CGI
