indexing

	description: "Test Posix file locking."

  author: "Berend de Boer"
	date: "$Date: Fri, 13 Oct 2000 13:53:08 +0200 $"
	revision: "$Revision: 1.8 $"

class TEST_P_LOCK

inherit
   
   POSIX_FORK_ROOT

   POSIX_FILE_SYSTEM
      rename
         make as make_file_system
      end

creation
   
   make



feature
   
   make is
      local
         lock: POSIX_LOCK
         fd: POSIX_FILE_DESCRIPTOR
      do
         print ("Testing Posix file locking interface.%N")

         make_file_system
         
         -- necessary under SmallEiffel
         ignore_child_stop_signal
         
         print ("Create a file.%N")
         create fd.create_read_write ("test.berend")
         fd.close_on_execute
         fd.write_string ("Test")

         print ("See if there is a read lock.%N")
         create lock.make
         lock.set_allow_read
         if fd.get_lock (lock) then
            print ("Quite unexpectedly, there is already a lock??%N")
         else
            print ("No lock yet.%N")
         end

         print ("Create an exclusive lock.%N")
         lock.set_allow_none
         lock.set_start (0)
         lock.set_length (4)
         fd.set_lock (lock)
         
         fork (Current)
         
         print ("Wait for child to terminate.%N")
         wait
        
         fd.close

         unlink ("test.berend")
         
         print ("End of Posix file locking test.%N")
      end


feature -- forked child   
   
   execute is
      local
         fd: POSIX_FILE_DESCRIPTOR
         lock: POSIX_LOCK
      do
         create fd.open_read ("test.berend")
         
         print ("See if there is a lock.%N")
         create lock.make
         lock.set_allow_read
         lock.set_start (2)
         lock.set_length (2)
         if fd.get_lock (lock) then
            print ("Yep, there's one.%N")
            print ("Locked by: ")
            print (lock.pid)
            print ("%N")
            print ("Lock starts at: ")
            print (lock.start)
            print ("%N")
         else
            print ("!! No lock.%N")
         end

         fd.close
      end
   

end -- class TEST_P_LOCK
